Index: LMDZ4/trunk/libf/phylmd/surf_land_orchidee_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/surf_land_orchidee_mod.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/surf_land_orchidee_mod.F90	(revision 987)
@@ -18,5 +18,5 @@
   USE comgeomphy,   ONLY : cuphy, cvphy
   USE mod_grid_phy_lmdz
-  USE mod_phys_lmdz_para
+  USE mod_phys_lmdz_para, mpi_root_rank=>mpi_root
 
   IMPLICIT NONE
@@ -25,4 +25,5 @@
   PUBLIC  :: surf_land_orchidee
 
+  LOGICAL, ALLOCATABLE, SAVE :: flag_omp(:)
 CONTAINS
 !
@@ -39,4 +40,7 @@
        tsol_rad, tsurf_new, alb1_new, alb2_new, &
        emis_new, z0_new, qsurf)
+   USE mod_surf_para
+   USE mod_synchro_omp
+   
 !    
 ! Cette routine sert d'interface entre le modele atmospherique et le 
@@ -163,5 +167,4 @@
 
     REAL, DIMENSION(knon,2)                   :: albedo_out
-    !$OMP THREADPRIVATE(albedo_out)
 
 ! Pb de nomenclature
@@ -188,4 +191,7 @@
     REAL, ALLOCATABLE, DIMENSION(:), SAVE     :: riverflow
     !$OMP THREADPRIVATE(riverflow)
+    
+    INTEGER :: orch_omp_rank
+    INTEGER :: orch_omp_size
 !
 ! Fin definition
@@ -198,7 +204,10 @@
   
     IF (debut) THEN
+       CALL Init_surf_para(knon)
        ALLOCATE(ktindex(knon))
        IF ( .NOT. ALLOCATED(albedo_keep)) THEN
-          ALLOCATE(albedo_keep(klon))
+!ym          ALLOCATE(albedo_keep(klon))
+!ym bizarre que non alloué en knon precedement
+          ALLOCATE(albedo_keep(knon))
           ALLOCATE(zlev(knon))
        ENDIF
@@ -333,5 +342,5 @@
     IF (lafin) lrestart_write = .TRUE.
     IF (check) WRITE(lunout,*)'lafin ',lafin,lrestart_write
-    
+     
     petA_orc(1:knon) = petBcoef(1:knon) * dtime
     petB_orc(1:knon) = petAcoef(1:knon)
@@ -352,26 +361,17 @@
 !  write(*,*)'Cdrag = ',minval(cdrag),maxval(cdrag)
 
-!
-! Init Orchidee
-!
-!  if (pole_nord) then 
-!    offset=0
-!    ktindex(:)=ktindex(:)+iim-1
-!  else
-!    offset = klon_mpi_begin-1+iim-1
-!    ktindex(:)=ktindex(:)+MOD(offset,iim)
-!    offset=offset-MOD(offset,iim)
-!  endif
   
     IF (debut) THEN
-       CALL Get_orchidee_communicator(knon,orch_comm)
-       IF (knon /=0) THEN
-          CALL Init_orchidee_index(knon,orch_comm,knindex,offset,ktindex)
-
-#ifndef CPP_PARA
-#define ORC_PREPAR
-#endif
-#ifdef ORC_PREPAR
-          ! Interface for ORCHIDEE version 1.9 or earlier compiled in sequential mode(without preprocessing flag CPP_PARA)
+       CALL Init_orchidee_index(knon,knindex,offset,ktindex)
+       CALL Get_orchidee_communicator(orch_comm,orch_omp_size,orch_omp_rank)
+       CALL Init_synchro_omp
+       
+       IF (knon_mpi > 0) THEN
+         CALL Init_intersurf(nbp_lon,nbp_lat,knon,ktindex,offset,orch_omp_size,orch_omp_rank,orch_comm)
+       ENDIF
+
+       
+       IF (knon > 0) THEN
+
           CALL intersurf_main (itime+itau_phy-1, iim, jjm+1, knon, ktindex, dtime, &
                lrestart_read, lrestart_write, lalo, &
@@ -383,19 +383,8 @@
                tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
                lon_scat, lat_scat)
-
-#else          
-          ! Interface for ORCHIDEE version 1.9 compiled in parallel mode(with preprocessing flag CPP_PARA)
-          CALL intersurf_main (itime+itau_phy-1, iim, jjm+1, offset, knon, ktindex, & 
-               orch_comm, dtime, lrestart_read, lrestart_write, lalo, &
-               contfrac, neighbours, resolution, date0, &
-               zlev,  u1_lay(1:knon), v1_lay(1:knon), spechum(1:knon), temp_air(1:knon), epot_air(1:knon), ccanopy(1:knon), &
-               cdrag(1:knon), petA_orc(1:knon), peqA_orc(1:knon), petB_orc(1:knon), peqB_orc(1:knon), &
-               precip_rain(1:knon), precip_snow(1:knon), lwdown(1:knon), swnet(1:knon), swdown(1:knon), ps(1:knon), &
-               evap(1:knon), fluxsens(1:knon), fluxlat(1:knon), coastalflow(1:knon), riverflow(1:knon), &
-               tsol_rad(1:knon), tsurf_new(1:knon), qsurf(1:knon), albedo_out(1:knon,:), emis_new(1:knon), z0_new(1:knon), &
-               lon_scat, lat_scat)
-#endif
-          
-       ENDIF
+         
+       ENDIF
+
+       CALL Synchro_omp
 
        albedo_keep(1:knon) = (albedo_out(1:knon,1)+albedo_out(1:knon,2))/2.
@@ -403,25 +392,12 @@
     ENDIF
 
+    
 !  swdown_vrai(1:knon) = swnet(1:knon)/(1. - albedo_keep(1:knon))
     swdown_vrai(1:knon) = swdown(1:knon)
 
-    IF (knon /=0) THEN
-    
-#ifdef ORC_PREPAR
-       ! Interface for ORCHIDEE version 1.9 or earlier compiled in sequential mode(without preprocessing flag CPP_PARA)
-       CALL intersurf_main (itime+itau_phy, iim, jjm+1, knon, ktindex, dtime, &
+    IF (knon > 0) THEN
+    
+       CALL intersurf_main (itime+itau_phy, iim, jjm+1, knon, ktindex, dtime,  &
             lrestart_read, lrestart_write, lalo, &
-            contfrac, neighbours, resolution, date0, &
-            zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
-            cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
-            precip_rain, precip_snow, lwdown, swnet, swdown_vrai, ps, &
-            evap, fluxsens, fluxlat, coastalflow, riverflow, &
-            tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
-            lon_scat, lat_scat)
-       
-#else
-       ! Interface for ORCHIDEE version 1.9 compiled in parallel mode(with preprocessing flag CPP_PARA)
-       CALL intersurf_main (itime+itau_phy, iim, jjm+1,offset, knon, ktindex, & 
-            orch_comm,dtime, lrestart_read, lrestart_write, lalo, &
             contfrac, neighbours, resolution, date0, &
             zlev,  u1_lay(1:knon), v1_lay(1:knon), spechum(1:knon), temp_air(1:knon), epot_air(1:knon), ccanopy(1:knon), &
@@ -431,8 +407,9 @@
             tsol_rad(1:knon), tsurf_new(1:knon), qsurf(1:knon), albedo_out(1:knon,:), emis_new(1:knon), z0_new(1:knon), &
             lon_scat, lat_scat)
-#endif
        
     ENDIF
 
+    CALL Synchro_omp
+    
     albedo_keep(1:knon) = (albedo_out(1:knon,1)+albedo_out(1:knon,2))/2.
 
@@ -455,124 +432,110 @@
     IF (debut) lrestart_read = .FALSE.
     
+    IF (debut) CALL Finalize_surf_para
+    
   END SUBROUTINE surf_land_orchidee
 !
 !****************************************************************************************
 !
-  SUBROUTINE Init_orchidee_index(knon,orch_comm,knindex,offset,ktindex)
-    
-    INCLUDE "dimensions.h"
-
+  SUBROUTINE Init_orchidee_index(knon,knindex,offset,ktindex)
+  USE mod_surf_para
+  USE mod_grid_phy_lmdz
+  
+    INTEGER,INTENT(IN)    :: knon
+    INTEGER,INTENT(IN)    :: knindex(klon)    
+    INTEGER,INTENT(OUT)   :: offset
+    INTEGER,INTENT(OUT)   :: ktindex(klon)
+    
+    INTEGER               :: ktindex_glo(knon_glo)
+    INTEGER               :: offset_para(0:omp_size*mpi_size-1)
+    INTEGER               :: LastPoint
+    INTEGER               :: task
+    
+    ktindex(1:knon)=knindex(1:knon)+(klon_mpi_begin-1)+(klon_omp_begin-1)+nbp_lon-1
+    
+    CALL gather_surf(ktindex(1:knon),ktindex_glo) 
+    
+    IF (is_mpi_root .AND. is_omp_root) THEN
+      LastPoint=0
+      DO Task=0,mpi_size*omp_size-1
+        IF (knon_glo_para(Task)>0) THEN
+           offset_para(task)= LastPoint-MOD(LastPoint,nbp_lon)
+           LastPoint=ktindex_glo(knon_glo_end_para(task))
+        ENDIF
+      ENDDO
+    ENDIF
+    
+    CALL bcast(offset_para)
+    
+    offset=offset_para(omp_size*mpi_rank+omp_rank)
+    
+    ktindex(1:knon)=ktindex(1:knon)-offset
+
+  END SUBROUTINE Init_orchidee_index
+
+!
+!************************* ***************************************************************
+! 
+
+  SUBROUTINE Get_orchidee_communicator(orch_comm,orch_omp_size,orch_omp_rank)
+  USE  mod_surf_para
+      
 #ifdef CPP_PARA
     INCLUDE 'mpif.h'
 #endif    
 
-
-! Input arguments
-!****************************************************************************************
-    INTEGER, INTENT(IN)                   :: knon
-    INTEGER, INTENT(IN)                   :: orch_comm
-    INTEGER, DIMENSION(klon), INTENT(IN)  :: knindex
-
-! Output arguments
-!****************************************************************************************
-    INTEGER, INTENT(OUT)                  :: offset
-    INTEGER, DIMENSION(knon), INTENT(OUT) :: ktindex
-
-! Local varables
-!****************************************************************************************
-#ifdef CPP_PARA
-    INTEGER, DIMENSION(MPI_STATUS_SIZE)   :: status
+    INTEGER,INTENT(OUT) :: orch_comm
+    INTEGER,INTENT(OUT) :: orch_omp_size
+    INTEGER,INTENT(OUT) :: orch_omp_rank
+    INTEGER             :: color
+    INTEGER             :: i,ierr
+!
+! End definition
+!****************************************************************************************
+    
+    
+    IF (is_omp_root) THEN          
+      
+      IF (knon_mpi==0) THEN 
+         color = 0
+      ELSE 
+         color = 1
+      ENDIF
+    
+#ifdef CPP_PARA    
+      CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
 #endif
 
-    INTEGER                               :: MyLastPoint
-    INTEGER                               :: LastPoint
-    INTEGER                               :: mpi_rank_orch
-    INTEGER                               :: mpi_size_orch
-    INTEGER                               :: ierr 
-!
-! End definition
-!****************************************************************************************
-
-    MyLastPoint=klon_mpi_begin-1+knindex(knon)+iim-1
-    
-    IF (is_parallel) THEN
-#ifdef CPP_PARA    
-       CALL MPI_COMM_SIZE(orch_comm,mpi_size_orch,ierr)
-       CALL MPI_COMM_RANK(orch_comm,mpi_rank_orch,ierr)
-#endif
-    ELSE
-       mpi_rank_orch=0
-       mpi_size_orch=1
-    ENDIF
-
-    IF (is_parallel) THEN
-       IF (mpi_rank_orch /= 0) THEN
-#ifdef CPP_PARA
-          CALL MPI_RECV(LastPoint,1,MPI_INTEGER,mpi_rank_orch-1,1234,orch_comm,status,ierr)
-#endif
-       ENDIF
-       
-       IF (mpi_rank_orch /= mpi_size_orch-1) THEN
-#ifdef CPP_PARA
-          CALL MPI_SEND(MyLastPoint,1,MPI_INTEGER,mpi_rank_orch+1,1234,orch_comm,ierr)  
-#endif
-       ENDIF
-    ENDIF
-    
-    IF (mpi_rank_orch == 0) THEN 
-       offset=0
-    ELSE
-       offset=LastPoint-MOD(LastPoint,iim)
-    ENDIF
-    
-    ktindex(1:knon)=knindex(1:knon)+(klon_mpi_begin+iim-1)-offset-1	
-    
-
-  END SUBROUTINE  Init_orchidee_index
-!
-!****************************************************************************************
-! 
-  SUBROUTINE Get_orchidee_communicator(knon,orch_comm)
-    
+   ENDIF
+   
+   IF (knon_mpi /= 0) THEN
+     orch_omp_size=0
+     DO i=0,omp_size-1
+       IF (knon_omp_para(i) /=0) THEN
+         orch_omp_size=orch_omp_size+1
+         IF (i==omp_rank) orch_omp_rank=orch_omp_size-1
+       ENDIF
+     ENDDO
+   ENDIF
+       
+    
+  END SUBROUTINE Get_orchidee_communicator
+!
+!****************************************************************************************
+!  
+
+  SUBROUTINE Init_neighbours(knon,neighbours,knindex,pctsrf)
+    USE mod_grid_phy_lmdz
+    USE mod_surf_para    
+    INCLUDE "indicesol.h"
+
 #ifdef CPP_PARA
     INCLUDE 'mpif.h'
 #endif    
 
-
-    INTEGER,INTENT(IN)  :: knon
-    INTEGER,INTENT(OUT) :: orch_comm
-    
-    INTEGER             :: color
-    INTEGER             :: ierr
-!
-! End definition
-!****************************************************************************************
-
-    IF (knon==0) THEN 
-       color = 0
-    ELSE 
-       color = 1
-    ENDIF
-    
-#ifdef CPP_PARA    
-    CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
-#endif
-    
-  END SUBROUTINE Get_orchidee_communicator
-!
-!****************************************************************************************
-!  
-  SUBROUTINE Init_neighbours(knon,neighbours,ktindex,pctsrf)
-    
-    INCLUDE "indicesol.h"
-    INCLUDE "dimensions.h"
-#ifdef CPP_PARA
-    INCLUDE 'mpif.h'
-#endif    
-
 ! Input arguments
 !****************************************************************************************
     INTEGER, INTENT(IN)                     :: knon
-    INTEGER, DIMENSION(klon), INTENT(IN)    :: ktindex
+    INTEGER, DIMENSION(klon), INTENT(IN)    :: knindex
     REAL, DIMENSION(klon), INTENT(IN)       :: pctsrf
     
@@ -583,99 +546,67 @@
 ! Local variables
 !****************************************************************************************
-    INTEGER                              :: knon_g
     INTEGER                              :: i, igrid, jj, ij, iglob
     INTEGER                              :: ierr, ireal, index
-    INTEGER, DIMENSION(0:mpi_size-1)     :: knon_nb
-    INTEGER, DIMENSION(0:mpi_size-1)     :: displs
     INTEGER, DIMENSION(8,3)              :: off_ini
     INTEGER, DIMENSION(8)                :: offset  
-    INTEGER, DIMENSION(knon)             :: ktindex_p
-    INTEGER, DIMENSION(iim,jjm+1)        :: correspond
-    INTEGER, ALLOCATABLE, DIMENSION(:)   :: ktindex_g
-    INTEGER, ALLOCATABLE, DIMENSION(:,:) :: neighbours_g
-    REAL, DIMENSION(klon_glo)            :: pctsrf_g
-    
+    INTEGER, DIMENSION(nbp_lon,nbp_lat)  :: correspond
+    INTEGER, DIMENSION(knon_glo)         :: ktindex_glo
+    INTEGER, DIMENSION(knon_glo,8)       :: neighbours_glo
+    REAL, DIMENSION(klon_glo)            :: pctsrf_glo
+    INTEGER                              :: ktindex(klon)
 !
 ! End definition
 !****************************************************************************************
 
-    IF (is_sequential) THEN
-       knon_nb(:)=knon
-    ELSE  
-       
-#ifdef CPP_PARA  
-       CALL MPI_GATHER(knon,1,MPI_INTEGER,knon_nb,1,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr)
-#endif
-       
-    ENDIF
-    
-    IF (is_mpi_root) THEN
-       knon_g=SUM(knon_nb(:))
-       ALLOCATE(ktindex_g(knon_g))
-       ALLOCATE(neighbours_g(knon_g,8))
-       neighbours_g(:,:)=-1
-       displs(0)=0
-       DO i=1,mpi_size-1
-          displs(i)=displs(i-1)+knon_nb(i-1)
-       ENDDO
-    ENDIF
-    
-    ktindex_p(1:knon)=ktindex(1:knon)+klon_mpi_begin-1+iim-1
-    
-    IF (is_sequential) THEN
-       ktindex_g(:)=ktindex_p(:)
-    ELSE
-       
-#ifdef CPP_PARA  
-       CALL MPI_GATHERV(ktindex_p,knon,MPI_INTEGER,ktindex_g,knon_nb,&
-            displs,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr)
-#endif
-       
-    ENDIF
-    
-    CALL Gather(pctsrf,pctsrf_g)
-    
-    IF (is_mpi_root) THEN
+    ktindex(1:knon)=knindex(1:knon)+(klon_mpi_begin-1)+(klon_omp_begin-1)+nbp_lon-1
+    
+    CALL gather_surf(ktindex(1:knon),ktindex_glo)
+    CALL gather(pctsrf,pctsrf_glo)
+    
+    IF (is_mpi_root .AND. is_omp_root) THEN
+      neighbours_glo(:,:)=-1
 !  Initialisation des offset    
 !
 ! offset bord ouest
-       off_ini(1,1) = - iim  ; off_ini(2,1) = - iim + 1; off_ini(3,1) = 1
-       off_ini(4,1) = iim + 1; off_ini(5,1) = iim      ; off_ini(6,1) = 2 * iim - 1
-       off_ini(7,1) = iim -1 ; off_ini(8,1) = - 1
+       off_ini(1,1) = - nbp_lon   ; off_ini(2,1) = - nbp_lon + 1     ; off_ini(3,1) = 1
+       off_ini(4,1) = nbp_lon + 1 ; off_ini(5,1) = nbp_lon           ; off_ini(6,1) = 2 * nbp_lon - 1
+       off_ini(7,1) = nbp_lon -1  ; off_ini(8,1) = - 1 
 ! offset point normal
-       off_ini(1,2) = - iim  ; off_ini(2,2) = - iim + 1; off_ini(3,2) = 1
-       off_ini(4,2) = iim + 1; off_ini(5,2) = iim      ; off_ini(6,2) = iim - 1
-       off_ini(7,2) = -1     ; off_ini(8,2) = - iim - 1
+       off_ini(1,2) = - nbp_lon   ; off_ini(2,2) = - nbp_lon + 1     ; off_ini(3,2) = 1
+       off_ini(4,2) = nbp_lon + 1 ; off_ini(5,2) = nbp_lon           ; off_ini(6,2) = nbp_lon - 1
+       off_ini(7,2) = -1          ; off_ini(8,2) = - nbp_lon - 1
 ! offset bord   est
-       off_ini(1,3) = - iim; off_ini(2,3) = - 2 * iim + 1; off_ini(3,3) = - iim + 1
-       off_ini(4,3) =  1   ; off_ini(5,3) = iim          ; off_ini(6,3) = iim - 1
-       off_ini(7,3) = -1   ; off_ini(8,3) = - iim - 1
+       off_ini(1,3) = - nbp_lon   ; off_ini(2,3) = - 2 * nbp_lon + 1 ; off_ini(3,3) = - nbp_lon + 1
+       off_ini(4,3) =  1          ; off_ini(5,3) = nbp_lon           ; off_ini(6,3) = nbp_lon - 1
+       off_ini(7,3) = -1          ; off_ini(8,3) = - nbp_lon - 1
 !
 !
 ! Attention aux poles
 !
-       DO igrid = 1, knon_g
-          index = ktindex_g(igrid)
-          jj = INT((index - 1)/iim) + 1
-          ij = index - (jj - 1) * iim
+       DO igrid = 1, knon_glo
+          index = ktindex_glo(igrid)
+          jj = INT((index - 1)/nbp_lon) + 1
+          ij = index - (jj - 1) * nbp_lon
           correspond(ij,jj) = igrid
        ENDDO
        
-       DO igrid = 1, knon_g
-          iglob = ktindex_g(igrid)
-          IF (MOD(iglob, iim) == 1) THEN
+       DO igrid = 1, knon_glo
+          iglob = ktindex_glo(igrid)
+          
+          IF (MOD(iglob, nbp_lon) == 1) THEN
              offset = off_ini(:,1)
-          ELSE IF(MOD(iglob, iim) == 0) THEN
+          ELSE IF(MOD(iglob, nbp_lon) == 0) THEN
              offset = off_ini(:,3)
           ELSE
              offset = off_ini(:,2)
           ENDIF
+          
           DO i = 1, 8
              index = iglob + offset(i)
-             ireal = (MIN(MAX(1, index - iim + 1), klon_glo))
-             IF (pctsrf_g(ireal) > EPSFRA) THEN
-                jj = INT((index - 1)/iim) + 1
-                ij = index - (jj - 1) * iim
-                neighbours_g(igrid, i) = correspond(ij, jj)
+             ireal = (MIN(MAX(1, index - nbp_lon + 1), klon_glo))
+             IF (pctsrf_glo(ireal) > EPSFRA) THEN
+                jj = INT((index - 1)/nbp_lon) + 1
+                ij = index - (jj - 1) * nbp_lon
+                neighbours_glo(igrid, i) = correspond(ij, jj)
              ENDIF
           ENDDO
@@ -684,20 +615,14 @@
     ENDIF
     
-    DO i=1,8
-       IF (is_sequential) THEN
-          neighbours(:,i)=neighbours_g(:,i)
-       ELSE
-#ifdef CPP_PARA
-          CALL MPI_SCATTERV(neighbours_g(:,i),knon_nb,displs,MPI_INTEGER,neighbours(:,i),knon,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr) 
+    DO i = 1, 8
+      CALL scatter_surf(neighbours_glo(:,i),neighbours(1:knon,i))
+    ENDDO
+  END SUBROUTINE Init_neighbours
+
+!
+!****************************************************************************************
+!
+
 #endif
-       ENDIF
-    ENDDO
-    
-  END SUBROUTINE Init_neighbours
-!
-!****************************************************************************************
-!
-
-#endif
 
 END MODULE surf_land_orchidee_mod
Index: LMDZ4/trunk/libf/phylmd/thermcell.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/thermcell.F	(revision 987)
@@ -52,5 +52,5 @@
       save idetr
       data idetr/3/
-
+c$OMP THREADPRIVATE(idetr)
 c   local:
 c   ------
@@ -94,4 +94,5 @@
       data isplit/0/
       save isplit
+c$OMP THREADPRIVATE(isplit)
 
       logical sorties
@@ -125,4 +126,5 @@
       data first /.false./
       save first
+c$OMP THREADPRIVATE(first)
 cRC
 
@@ -137,4 +139,5 @@
       save ncorrec
       data ncorrec/0/
+c$OMP THREADPRIVATE(ncorrec)
       
 c
@@ -1131,4 +1134,5 @@
 c$OMP THREADPRIVATE(zmax0_sec)
       logical, save :: first = .true.
+c$OMP THREADPRIVATE(first)
 
       if (first) then
Index: LMDZ4/trunk/libf/phylmd/thermcell.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell.h	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/thermcell.h	(revision 987)
@@ -8,2 +8,3 @@
       common/ctherm3/w2di_thermals
       common/ctherm4/iflag_coupl,iflag_clos,iflag_wake
+!$OMP THREADPRIVATE(/ctherm1/,/ctherm2/,/ctherm3/,/ctherm4/)
Index: LMDZ4/trunk/libf/phylmd/thermcell_flux.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell_flux.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/thermcell_flux.F90	(revision 987)
@@ -49,4 +49,5 @@
       REAL fomass_max,alphamax
       save fomass_max,alphamax
+!$OMP THREADPRIVATE(fomass_max,alphamax)
 
       fomass_max=0.5
Index: LMDZ4/trunk/libf/phylmd/thermcell_flux2.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell_flux2.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/thermcell_flux2.F90	(revision 987)
@@ -45,4 +45,5 @@
       REAL fomass_max,alphamax
       save fomass_max,alphamax
+!$OMP THREADPRIVATE(fomass_max,alphamax)
 
       fomass_max=0.5
Index: LMDZ4/trunk/libf/phylmd/thermcell_main.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell_main.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/thermcell_main.F90	(revision 987)
@@ -69,8 +69,12 @@
       data icount/0/
       save icount
+!$OMP THREADPRIVATE(icount)
 
       integer,save :: igout=1
+!$OMP THREADPRIVATE(igout)
       integer,save :: lunout1=6
+!$OMP THREADPRIVATE(lunout1)
       integer,save :: lev_out=10
+!$OMP THREADPRIVATE(lev_out)
 
       INTEGER ig,k,l,ll
@@ -118,4 +122,5 @@
       data isplit/0/
       save isplit
+!$OMP THREADPRIVATE(isplit)
 
       logical sorties
Index: LMDZ4/trunk/libf/phylmd/thermcell_old.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell_old.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/thermcell_old.F	(revision 987)
@@ -53,4 +53,5 @@
       save idetr
       data idetr/3/
+c$OMP THREADPRIVATE(idetr)
 
 c   local:
@@ -88,4 +89,5 @@
       data isplit/0/
       save isplit
+c$OMP THREADPRIVATE(isplit)
 
       logical sorties
@@ -117,4 +119,6 @@
       save ncorrec
       data ncorrec/0/
+c$OMP THREADPRIVATE(ncorrec)
+
 c
 c-----------------------------------------------------------------------
@@ -852,4 +856,5 @@
       save idetr
       data idetr/3/
+c$OMP THREADPRIVATE(idetr)
 
 c   local:
@@ -865,4 +870,6 @@
       save alpha
       data alpha/1./
+c$OMP THREADPRIVATE(alpha)
+
 c RC 
       real zmax(klon),zw,zz,zw2(klon,klev+1),ztva(klon,klev),zzz
@@ -918,4 +925,5 @@
       data isplit/0/
       save isplit
+c$OMP THREADPRIVATE(isplit)
 
       logical sorties
@@ -977,4 +985,5 @@
       real zlevinter(klon)
       logical, save :: first = .true.
+c$OMP THREADPRIVATE(first)
 c      data first /.false./
 c      save first
@@ -1000,4 +1009,6 @@
       save ncorrec
       data ncorrec/0/
+c$OMP THREADPRIVATE(ncorrec)
+
 c
 
@@ -2648,4 +2659,5 @@
       save idetr
       data idetr/3/
+c$OMP THREADPRIVATE(idetr)
 
 c   local:
@@ -2692,4 +2704,5 @@
       data isplit/0/
       save isplit
+c$OMP THREADPRIVATE(isplit)
 
       logical sorties
@@ -2727,4 +2740,6 @@
       data first /.false./
       save first
+c$OMP THREADPRIVATE(first)
+
 cRC
 
@@ -2740,4 +2755,6 @@
       save ncorrec
       data ncorrec/0/
+c$OMP THREADPRIVATE(ncorrec)
+
 c
 
@@ -3755,4 +3772,5 @@
       save idetr
       data idetr/3/
+c$OMP THREADPRIVATE(idetr)
 
 c   local:
@@ -3796,4 +3814,5 @@
       data isplit/0/
       save isplit
+c$OMP THREADPRIVATE(isplit)
 
       logical sorties
@@ -3823,4 +3842,5 @@
       data first /.false./
       save first
+c$OMP THREADPRIVATE(first)
 cRC
 
@@ -3835,4 +3855,5 @@
       save ncorrec
       data ncorrec/0/
+c$OMP THREADPRIVATE(ncorrec)
       
 c
@@ -5160,4 +5181,5 @@
       save idetr
       data idetr/3/
+c$OMP THREADPRIVATE(idetr)
 
 c   local:
@@ -5201,4 +5223,5 @@
       data isplit/0/
       save isplit
+c$OMP THREADPRIVATE(isplit)
 
       logical sorties
@@ -5228,4 +5251,5 @@
       data first /.false./
       save first
+c$OMP THREADPRIVATE(first)
 cRC
 
@@ -5240,4 +5264,5 @@
       save ncorrec
       data ncorrec/0/
+c$OMP THREADPRIVATE(ncorrec)
       
 c
Index: LMDZ4/trunk/libf/phylmd/yamada.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/yamada.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/yamada.F	(revision 987)
@@ -55,5 +55,5 @@
       save first
       data first/.true./
-
+c$OMP THREADPRIVATE(first)
 
       integer ig,k
@@ -71,4 +71,5 @@
       save ric,rifc,b1,kap
       data ric,rifc,b1,kap/0.195,0.191,16.6,0.3/
+c$OMP THREADPRIVATE(ric,rifc,b1,kap)
 
       real frif,falpha,fsm
